// rclick.cpp : Defines the entry point for the application.
//

#include "stdafx.h"
#include "resource.h"
#include <htmlhelp.h>
#include <shlobj.h>

#define MAX_LOADSTRING 100
#define ID_EDIT 100

// Global Variables:
HINSTANCE hInst;								// current instance
TCHAR szTitle[MAX_LOADSTRING];								// The title bar text
TCHAR szWindowClass[MAX_LOADSTRING];								// The title bar text

// Foward declarations of functions included in this code module:
ATOM				MyRegisterClass(HINSTANCE hInstance);
BOOL				InitInstance(HINSTANCE, int);
LRESULT CALLBACK	WndProc(HWND, UINT, WPARAM, LPARAM);
LRESULT CALLBACK	About(HWND, UINT, WPARAM, LPARAM);

LPCONTEXTMENU2 g_lpContextMenu2=NULL;

#define COUNTOF(x) sizeof(x)/sizeof(x[0])

int APIENTRY WinMain(HINSTANCE hInstance,
                     HINSTANCE hPrevInstance,
                     LPSTR     lpCmdLine,
                     int       nCmdShow)
{
 	// TODO: Place code here.
	MSG msg;
	HACCEL hAccelTable;

	// Initialize global strings
	LoadString(hInstance, IDS_APP_TITLE, szTitle, MAX_LOADSTRING);
	LoadString(hInstance, IDC_RCLICK, szWindowClass, MAX_LOADSTRING);
	MyRegisterClass(hInstance);
	CoInitialize(NULL);

	// Perform application initialization:
	if (!InitInstance (hInstance, nCmdShow)) 
	{
		return FALSE;
	}

	hAccelTable = LoadAccelerators(hInstance, (LPCTSTR)IDC_RCLICK);

	// Main message loop:
	while (GetMessage(&msg, NULL, 0, 0)) 
	{
		if (!TranslateAccelerator(msg.hwnd, hAccelTable, &msg)) 
		{
			TranslateMessage(&msg);
			DispatchMessage(&msg);
		}
	}
	CoUninitialize();

	return 0;
}



//
//  FUNCTION: MyRegisterClass()
//
//  PURPOSE: Registers the window class.
//
//  COMMENTS:
//
//    This function and its usage is only necessary if you want this code
//    to be compatible with Win32 systems prior to the 'RegisterClassEx'
//    function that was added to Windows 95. It is important to call this function
//    so that the application will get 'well formed' small icons associated
//    with it.
//
ATOM MyRegisterClass(HINSTANCE hInstance)
{
	WNDCLASSEX wcex;

	wcex.cbSize = sizeof(WNDCLASSEX); 

	wcex.style			= CS_HREDRAW | CS_VREDRAW;
	wcex.lpfnWndProc	= (WNDPROC)WndProc;
	wcex.cbClsExtra		= 0;
	wcex.cbWndExtra		= 0;
	wcex.hInstance		= hInstance;
	wcex.hIcon			= LoadIcon(hInstance, (LPCTSTR)IDI_RCLICK);
	wcex.hCursor		= LoadCursor(NULL, IDC_ARROW);
	wcex.hbrBackground	= (HBRUSH)(COLOR_WINDOW+1);
	wcex.lpszMenuName	= (LPTSTR)IDC_RCLICK;
	wcex.lpszClassName	= szWindowClass;
	wcex.hIconSm		= LoadIcon(wcex.hInstance, (LPCTSTR)IDI_SMALL);

	return RegisterClassEx(&wcex);
}

//
//   FUNCTION: InitInstance(HANDLE, int)
//
//   PURPOSE: Saves instance handle and creates main window
//
//   COMMENTS:
//
//        In this function, we save the instance handle in a global variable and
//        create and display the main program window.
//
BOOL InitInstance(HINSTANCE hInstance, int nCmdShow)
{
   HWND hWnd;

   hInst = hInstance; // Store instance handle in our global variable

   hWnd = CreateWindow(szWindowClass, szTitle, WS_OVERLAPPEDWINDOW,
      CW_USEDEFAULT, 0, CW_USEDEFAULT, 0, NULL, NULL, hInstance, NULL);

   if (!hWnd)
   {
      return FALSE;
   }

   TCHAR buffer[256];
   buffer[0]=0;
   GetEnvironmentVariable(TEXT("WINDIR"),buffer,COUNTOF(buffer));
   if (buffer[0]==0)
	   _tcscat_s(buffer,COUNTOF(buffer),TEXT("C:\\WINDOWS\\"));
   else if (buffer[_tcslen(buffer)-1]!='\\')
		_tcscat_s(buffer,COUNTOF(buffer),TEXT("\\"));
   _tcscat_s(buffer,COUNTOF(buffer),TEXT("notepad.exe"));

   SetWindowLong(CreateWindow(TEXT("EDIT"),buffer,WS_CHILD | WS_TABSTOP | WS_VISIBLE | WS_BORDER | ES_AUTOHSCROLL,
      20,48,300,24,hWnd,0,hInst,NULL),GWL_ID,ID_EDIT);

   ShowWindow(hWnd, nCmdShow);
   UpdateWindow(hWnd);

   return TRUE;
}

void showrightclickmenu(HWND hWnd,TCHAR* fullpath)
{
	LPSHELLFOLDER DesktopFolder,CurrentDir;
	LPITEMIDLIST idlist;
	LPITEMIDLIST* lpidl;
	LPCONTEXTMENU lpcm;
	HRESULT res;
	HMENU menu;
	POINT pt;
	CMINVOKECOMMANDINFOEX cmi;
	WCHAR unicodename[MAX_PATH];
	TCHAR* p;
	TCHAR ch;

	res=SHGetDesktopFolder(&DesktopFolder);
	if (!SUCCEEDED(res))
		return;

	p=_tcsrchr(fullpath,'\\');
	if (!p) return;

	ch=p[1];
	p[1]=0;
#ifdef UNICODE
	wcscpy_s(unicodename,MAX_PATH,fullpath);
#else
	MultiByteToWideChar(CP_ACP, 0, fullpath, -1, unicodename, MAX_PATH);
#endif
	p[1]=ch;
	res=DesktopFolder->ParseDisplayName(hWnd,NULL,unicodename,NULL,&idlist,NULL);
	if (!SUCCEEDED(res)) {
		MessageBox(hWnd,TEXT("Path name not found!"),TEXT("RCLICK"),MB_ICONSTOP);
		return;
	}
	res=DesktopFolder->BindToObject(idlist, NULL, IID_IShellFolder,(void**) &CurrentDir);
	DesktopFolder->Release();
	if (!SUCCEEDED(res)) {
		MessageBox(hWnd,TEXT("No shell folder obtained!"),TEXT("RCLICK"),MB_ICONSTOP);
		return;
	}
#ifdef UNICODE
	wcscpy_s(unicodename,MAX_PATH,p+1);
#else
	MultiByteToWideChar(CP_ACP, 0, p+1, -1, unicodename, MAX_PATH);
#endif
	res=CurrentDir->ParseDisplayName(hWnd,NULL,unicodename,NULL,&idlist,NULL);
	if (!SUCCEEDED(res)) {
		MessageBox(hWnd,TEXT("File name not found!"),TEXT("RCLICK"),MB_ICONSTOP);
		return;
	}

	lpidl=&idlist;
	res=CurrentDir->GetUIObjectOf(hWnd, 1,  
        (const struct _ITEMIDLIST **)lpidl, IID_IContextMenu, NULL,(void**) &lpcm);
	if (!SUCCEEDED(res)) {
		MessageBox(hWnd,TEXT("Context menu creation failed!"),TEXT("RCLICK"),MB_ICONSTOP);
		return;
	}
	lpcm->QueryInterface(IID_IContextMenu2,(void**) &g_lpContextMenu2);


	menu=CreatePopupMenu();
    if (menu) {
		res=lpcm->QueryContextMenu(menu, 0, 100, 0x7fff, CMF_CANRENAME);
		GetCursorPos(&pt);
		if SUCCEEDED(res) {
			res=(int)(TrackPopupMenu(menu,
	            TPM_LEFTALIGN | TPM_RETURNCMD | TPM_RIGHTBUTTON,
		        pt.x, pt.y, 0, hWnd, NULL));
			if (res) {
				memset(&cmi,0,sizeof(cmi));
				cmi.cbSize = sizeof(cmi);
				cmi.hwnd   = hWnd;
				cmi.lpVerb = MAKEINTRESOURCEA(res-100);
				cmi.lpVerbW= MAKEINTRESOURCEW(res-100);
				cmi.nShow  = SW_SHOWNORMAL;
                res=lpcm->InvokeCommand((LPCMINVOKECOMMANDINFO)&cmi);
				if (res!=0) {
					TCHAR buffer[256];
					FormatMessage(FORMAT_MESSAGE_FROM_SYSTEM | FORMAT_MESSAGE_ARGUMENT_ARRAY | FORMAT_MESSAGE_IGNORE_INSERTS,
						NULL, res, 0, buffer,
						COUNTOF(buffer), NULL);
					MessageBox(hWnd,buffer,TEXT("RCLICK"),MB_ICONSTOP);
				}
			}
		} else
			MessageBox(hWnd,TEXT("Query context menu failed!"),TEXT("RCLICK"),MB_ICONSTOP);
		DestroyMenu(menu);
	}	
	lpcm->Release();
	if (g_lpContextMenu2)
		g_lpContextMenu2->Release();
	g_lpContextMenu2=NULL;

	CurrentDir->Release();
}			

void OpenHelpFile() {
	SetErrorMode(0x8001);
    HtmlHelpA(0, "TOTALCMD.CHM", HH_DISPLAY_TOC,0);//HH_HELP_FINDER, 0);
}

//
//  FUNCTION: WndProc(HWND, unsigned, WORD, LONG)
//
//  PURPOSE:  Processes messages for the main window.
//
//  WM_COMMAND	- process the application menu
//  WM_PAINT	- Paint the main window
//  WM_DESTROY	- post a quit message and return
//
//
LRESULT CALLBACK WndProc(HWND hWnd, UINT message, WPARAM wParam, LPARAM lParam)
{
	int wmId, wmEvent;
	PAINTSTRUCT ps;
	HDC hdc;
	TCHAR buf[MAX_PATH];

	if (g_lpContextMenu2) {
		switch (message) 
		{
			case WM_INITMENUPOPUP:
				g_lpContextMenu2->HandleMenuMsg(message, wParam, lParam);
				return 0;
			case WM_MEASUREITEM:
			case WM_DRAWITEM:
			case WM_DELETEITEM:
				if (wParam==0) {
					g_lpContextMenu2->HandleMenuMsg(message, wParam, lParam);
					return 1;
				}
		}
	}

	switch (message) 
	{
		case WM_KEYDOWN:
			if (wParam==VK_F1)
				OpenHelpFile();
			break;
		case WM_RBUTTONDOWN:
			GetDlgItemText(hWnd,ID_EDIT,buf,COUNTOF(buf)-1);
			showrightclickmenu(hWnd,buf);
			break;
		case WM_COMMAND:
			wmId    = LOWORD(wParam); 
			wmEvent = HIWORD(wParam); 
			// Parse the menu selections:
			switch (wmId)
			{
				case IDM_ABOUT:
				   DialogBox(hInst, (LPCTSTR)IDD_ABOUTBOX, hWnd, (DLGPROC)About);
				   break;
				case IDM_EXIT:
				   DestroyWindow(hWnd);
				   break;
				default:
				   return DefWindowProc(hWnd, message, wParam, lParam);
			}
			break;
		case WM_PAINT:
			hdc = BeginPaint(hWnd, &ps);
			// TODO: Add any drawing code here...
			RECT rt;
			GetClientRect(hWnd, &rt);
			DrawText(hdc, TEXT("  Right click to show context menu of the following object, then click on 'Share':"), -1, &rt, DT_LEFT);
			EndPaint(hWnd, &ps);
			break;
		case WM_DESTROY:
			PostQuitMessage(0);
			break;
		default:
			return DefWindowProc(hWnd, message, wParam, lParam);
   }
   return 0;
}

// Mesage handler for about box.
LRESULT CALLBACK About(HWND hDlg, UINT message, WPARAM wParam, LPARAM lParam)
{
	switch (message)
	{
		case WM_INITDIALOG:
				return TRUE;

		case WM_COMMAND:
			if (LOWORD(wParam) == IDOK || LOWORD(wParam) == IDCANCEL) 
			{
				EndDialog(hDlg, LOWORD(wParam));
				return TRUE;
			}
			break;
	}
    return FALSE;
}
